#ifndef LQFT_CONFIG_H_
#define LQFT_CONFIG_H_

#define _VERSION_ "refactored-v1.597-SF0.942"

#define _NTX 32
#define _NTY 32
#define _NTZ 32
#define _NTT 64

#define _NDIMX  2
#define _NDIMY  2
#define _NDIMZ  1

#undef _SF
#define _SF_BOUNDARY_TYPE 0

#define _RGGAUGE

#define _CLOVER

#define _HMC_SOLVER_ bicgstab_alg

#define _CLV_SOLVER  clvinv_ldl


#undef _USE_BLOCK_SOLVER

#if _NDIMX > 1
#define _DEPTHX 1
#else
#define _DEPTHX 0
#endif
#if _NDIMY > 1
#define _DEPTHY 1
#else
#define _DEPTHY 0
#endif
#if _NDIMZ > 1
#define _DEPTHZ 1
#else
#define _DEPTHZ 0
#endif
#undef _singlePU
#if (_DEPTHX==0) && (_DEPTHY==0) && (_DEPTHZ==0)
#define _singlePU
#endif

#define _NX (_NTX/_NDIMX)
#define _NY (_NTY/_NDIMY)
#define _NZ (_NTZ/_NDIMZ)

#ifdef _USE_BLOCK_SOLVER
#ifndef _singlePU
#error Block-solver cannot be used in node-parallel lattice setup. (undef _USE_BLOCK_SOLVER)
#endif
#endif


#undef _REVCHECK



#endif
