module solver_parameter_class
!
!= Solver parameter class used in HMC program 
!
!== Version
!
! $Id: solver_parameter_class.F90,v 1.6 2010/07/31 13:41:36 ishikawa Exp $
!
  use constants_module
  use counter_class
  implicit none
  private
  public :: solver_parameter, new, inc, get_average

  type solver_parameter
  !
  ! solver parameter
  !
    real(DP),       public :: tol             ! solver tolerance
    type(counter), private :: solver_counter  ! solver iteration counter
  end type

  interface new
    module procedure  new_solver
  end interface

  interface inc
    module procedure  inc_solver
  end interface

  interface get_average
    module procedure  get_average_solver
  end interface

contains

subroutine new_solver(this)
  implicit none
  type(solver_parameter), intent(out) :: this
  this%tol=EPSILON(this%tol)
  call new(this%solver_counter)
  return
end subroutine

subroutine inc_solver(this,incl)
  implicit none
  type(solver_parameter), intent(inout) :: this
  integer, optional, intent(in) :: incl
  if (present(incl)) then
    call inc(this%solver_counter,incl)
  else
    call inc(this%solver_counter)
  endif
  return
end subroutine

function get_average_solver(this) result(ave)
  implicit none
  type(solver_parameter), intent(inout) :: this
  real(DP) :: ave
  ave = get_average(this%solver_counter)
  return
end function

end module
